include masm32rt.inc
.686p
.mmx
.xmm
include \macro\smplmath\math.inc
include LibSinText.inc

.code
JmpSine proc uses ebx edi esi hDC:HDC,flg:DWORD,_t:DWORD,x0:DWORD,y0:DWORD,v:REAL4,T:DWORD,A:DWORD,dPhi:REAL4,psz:PCHAR,_dx:DWORD
LOCAL rect:RECT
LOCAL _size:_SIZE
LOCAL cc:DWORD
LOCAL x:REAL4
LOCAL lambda:REAL4
LOCAL omega:REAL4
LOCAL f:REAL4
LOCAL k:REAL4
LOCAL phi:REAL4
LOCAL tmp:REAL4
LOCAL t:REAL4
LOCAL _dq:QWORD
LOCAL fSlvTLS()
	
	mov esi,psz
	mov cc,len(esi)

	m2m DWORD ptr _dq,_t
	mov DWORD ptr _dq+4,0
	fSlv t = _dq*0.001

	.if flg & JS_XT_WAVE
		fSlv lambda = T
		fSlv f = v/lambda
		fSlv omega = 2*pi*f
		fSlv k = 2*pi/lambda
		
		fSlv x = x0
		mov _size.x,0
		xor edi,edi
		.while edi < cc
			invoke GetTextExtentPoint32,hDC,ADDR [esi+edi],1,ADDR _size
			fSlv tmp = A*sin(k*(x+_size.x*0.5) - omega*t + dPhi)
			.if flg & JS_UPPER_ONLY && tmp & 80000000h
				fSlv tmp = 0
			.elseif flg & JS_LOWER_ONLY && !(tmp & 80000000h)
				fSlv tmp = 0
			.elseif flg & JS_FOLD_UP && tmp & 80000000h
				fSlv tmp = abs(tmp)
			.elseif flg & JS_FOLD_DOWN && !(tmp & 80000000h)
				fSlv tmp = -tmp
			.endif
			invoke TextOut,hDC,@fSlvI(x),@fSlvI(y0-tmp),ADDR [edi+esi],1		
			fSlv x = x+_size.x
			inc edi
		.endw
		
	.elseif flg & JS_T_WAVE
		
		.if flg & JS_HORZ_OSCILLATION
			invoke GetTextExtentPoint32,hDC,esi,cc,ADDR _size
			fSlvRegExpr <Tri>,1,arg1^(-2)*cos(arg1*(t*omega))+(arg1+2)^-2*cos((arg1+2)*(t*omega))+(arg1+4)^-2*cos((arg1+4)*(t*omega))
			fSlv tmp = (_dx-_size.x)/2
			fSlv omega = pi*v/(_dx-_size.x)
			
			;fourier series for oscillation (triangular pulse)
			fSlv x = x0 + tmp - (100/120.59)*tmp*(Tri(1)+Tri(7)+Tri(13))
		.else
			fSlv x = x0 + v*t
		.endif

		mov _size.x,0
		xor edi,edi
		.while edi < cc
			invoke GetTextExtentPoint32,hDC,ADDR [esi+edi],1,ADDR _size
			fSlv phi = (x+_size.x*0.5)*2*pi/T
			fSlv tmp = A*cos(phi+dPhi)
			.if flg & JS_UPPER_ONLY && tmp & 80000000h
				fSlv tmp = 0
			.elseif flg & JS_LOWER_ONLY && !(tmp & 80000000h)
				fSlv tmp = 0
			.elseif flg & JS_FOLD_UP && tmp & 80000000h
				fSlv tmp = abs(tmp)
			.elseif flg & JS_FOLD_DOWN && !(tmp & 80000000h)
				fSlv tmp = -tmp
			.endif
			invoke TextOut,hDC,@fSlvI(x),@fSlvI(y0-tmp),ADDR [edi+esi],1		
			fSlv x = x+_size.x
			inc edi
		.endw
	.endif
	
	ret
	
JmpSine endp
end